function research_complete(empire)
  local researching in empire

  acquire_tech(empire, researching, 'research')
end

function acquire_tech(empire, acquired_tech, learned)

  empire.tech.known[acquired_tech] = {learned = learned}

  --if we were researching this tech, advance the research queue
  if empire.researching == acquired_tech
    empire.researching = nil 

    if empire.research_queue
      local q = copy | empire.research_queue
      if q[2]
        for i=1,100
          if not q[1]
            empire.research_queue=nil
            break
          end
          table.remove(q,1)
          if empire:researchable( q[1] )
            empire.researching=q[1]
            empire.research_queue=q
            break
          end
        end
      else
        empire.research_queue=nil
      end

    end

  --otherwise, remove it from the queue if it's there
  elseif empire.research_queue
    --modifying the current queue didn't work (table.remove() fails because research_queue is userdata???)
    --so just rebuild the queue
    local new_queue = {}
    for i,tech in ipairs(empire.research_queue) do
      if tech ~= acquired_tech
        new_queue[#new_queue+1] = tech
      end
    end
    empire.research_queue = new_queue
  end

  -- generate the tech report
  local no_queue = not empire.researching
  local old_drive_speed,old_command_range,old_drive_range,old_scan_range,new_designs in
    on_tech_gained(empire,acquired_tech)

  local r = light_report_search(empire,type='tech')
  if not r
    add_report{
      ..no_queue,
      empire=empire,
      new_hulls = new_designs,
      type = "tech",
      tech = acquired_tech,
      completed_list = {acquired_tech},
      ..old_drive_speed,
      ..old_command_range,
      ..old_drive_range,
      ..old_scan_range,
    }
  else -- r.completed_list
    if not r.completed_list
      r.completed_list={}
    end
    r.completed_list[#r.completed_list+1]=acquired_tech
    r.new_hulls = join(copy(r.new_hulls),new_designs)
  end

  -- check for any bonus techs
  for i, tech in ipairs(empire.tech:leads_to(acquired_tech)) do
    if empire.tech:is_bonus_tech(tech) and empire.tech:researchable(tech)
      acquire_tech(empire, tech, learned)
    end
  end

end